### Namespace

# Clapper – 0.0

Clapper playback library

Version | 0.6.1
Authors | Rafał Dzięgiel
License | LGPL-2.1-or-later
Website | https://rafostar.github.io/clapper/
Source | https://github.com/Rafostar/clapper/

#### Build

C headers | `clapper/clapper.h`
pkg-config files | `clapper-0.0`

#### Dependencies

GLib—2.0 | A general-purpose, portable utility library
| Browse documentation
GObject—2.0 | The base type system library
| Browse documentation
Gio—2.0 | GObject Interfaces and Objects, Networking, IPC, and I/O
| Browse documentation
Gst—1.0 | GStreamer core library
| Browse documentation
GstBase—1.0 | GStreamer base and utility classes
| Browse documentation
GstAudio—1.0 | GStreamer audio library
| Browse documentation
GstPbutils—1.0 | GStreamer base utils library
| Browse documentation
GstTag—1.0 | GStreamer tag support library
| Browse documentation

#### Additional documentation

- Classes Hierarchy

#### Classes

AudioStream | Represents an audio stream within media.
Discoverer | An optional Discoverer feature to be added to the player.
Feature | A base class for creating new features for the player.
Marker | Represents a point in timeline.
MediaItem | Represents a media item.
Mpris | An optional `MPRIS` feature to add to the player.
Player | The media player object used for playback.
Queue | A queue of media to be played.
Server | An optional Server feature to add to the player.
Stream | Represents a stream within media.
StreamList | A list of media streams.
SubtitleStream | Represents a subtitle stream within media.
ThreadedObject | A base class for creating objects that work within a separate thread.
Timeline | A media timeline filled with point markers.
VideoStream | Represents a video stream within media.

#### Enumerations

DiscovererDiscoveryMode |
MarkerType |
PlayerSeekMethod |
PlayerState |
QueueProgressionMode |
StreamType |

#### Functions

init | Initializes the Clapper library. Implementations must always call this before using Clapper API.
init_check | This function does the same thing as `clapper_init()`, but instead of terminating on failure it returns `FALSE`.

#### Function Macros

AUDIO_STREAM_CAST |
CHECK_VERSION |
DISCOVERER_CAST |
ENCODE_VERSION |
FEATURE_CAST |
MARKER_CAST |
MEDIA_ITEM_CAST |
MPRIS_CAST |
PLAYER_CAST |
QUEUE_CAST |
SERVER_CAST |
STREAM_CAST |
STREAM_LIST_CAST |
SUBTITLE_STREAM_CAST |
THREADED_OBJECT_CAST |
TIME_ARGS | Formats `t` for the `CLAPPER_TIME_FORMAT` format string.
TIME_MS_ARGS | Formats `t` for the `CLAPPER_TIME_MS_FORMAT` format string.
TIMELINE_CAST |
VIDEO_STREAM_CAST |

#### Constants

HAVE_DISCOVERER | Check if Clapper was compiled with Discoverer feature.
HAVE_MPRIS | Check if Clapper was compiled with MPRIS feature.
HAVE_SERVER | Check if Clapper was compiled with Server feature.
MAJOR_VERSION | Clapper major version component.
MARKER_NO_END | The value used to indicate that marker does not have an ending time specified.
MICRO_VERSION | Clapper micro version component.
MINOR_VERSION | Clapper minor version component.
QUEUE_INVALID_POSITION | The value used to refer to an invalid position in a `ClapperQueue`.
STREAM_LIST_INVALID_POSITION | The value used to refer to an invalid position in a `ClapperStreamList`.
TIME_FORMAT | A string that can be used in printf-like format to display e.g. position or duration in `hh:mm:ss` format. Meant to be used together with `CLAPPER_TIME_ARGS()`.
TIME_MS_FORMAT | Same as `CLAPPER_TIME_FORMAT`, but also displays milliseconds. Meant to be used together with `CLAPPER_TIME_MS_ARGS()`.
VERSION_S | Clapper version, encoded as a string.